# This is the script file, no need to edit this (Besides admin part). Edit the props.txt file!

Admins = ['STEAM_0:1:123456','STEAM_0:1:654321','STEAM_0:1:7589873'] # the admins
SayCommand = "!props" # command to open the menu

import es
import psyco
import vecmath
import popuplib
import playerlib
psyco.full()
CFGPath = str(es.getAddonPath("props")).replace("\\addons", "\\cfg").replace("/addons", "/cfg")
PropsFile = open(CFGPath + '/props.txt').readlines()
RotateFile = open(CFGPath + '/rotate.txt').readlines()
def load():
    global Props_Main
    Props_Main = popuplib.easymenu('Props_Main',None, SendPopup)
    Props_Main.settitle("- Props")
    Props_Main.addoption("Props_Manage_Main","Manage Props")
    Props_Main.addoption("Props_Delete_Main","Delete Props")
    Props_Main.addoption("Props_Props_Main","Spawn Props")
    
    global Props_Delete_Main
    Props_Delete_Main = popuplib.easymenu('Props_Delete_Main',None, Deleter)
    Props_Delete_Main.submenu(10,Props_Main)
    Props_Delete_Main.settitle("- Props\n-- Delete Props")
    Props_Delete_Main.addoption('DeleteThis', 'Delete This Prop')
    Props_Delete_Main.addoption('DeleteAll', 'Delete All Props')
    global Props_Manage_Main
    Props_Manage_Main = popuplib.easymenu('Props_Manage_Main',None, SendPopup)
    Props_Manage_Main.submenu(10,Props_Main)
    Props_Manage_Main.settitle("- Props\n-- Manage Props")
    Props_Manage_Main.addoption('Props_Rotate_Main', 'Rotate Props')
    global Props_Rotate_Main
    Props_Rotate_Main = popuplib.easymenu('Props_Rotate_Main',None, SendPopup)
    Props_Rotate_Main.submenu(10, 'Props_Manage_Main')
    Props_Rotate_Main.settitle("- Props\n-- Manage Props\n--- Rotate")
    
    SetUpRotate()
    SetUpProps()
    es.msg("#multi","#greenProps #default[#darkgreenV%s#default] #lightgreenhas been loaded" %(str(PubVar).lower().replace('cheetah-public','')))
def unload():
    es.msg("#multi","#greenProps #default[#darkgreenV%s#default] #lightgreenhas been unloaded" %(str(PubVar).lower().replace('cheetah-public','')))
def player_say(ev):
    if str(ev['text']).lower() == str(SayCommand).lower():
        for Admin in Admins:
            if str(ev['es_steamid']).lower() == str(Admin).lower():
                SendPopup(ev['userid'],'Props_Main')
                return
        es.tell(ev['userid'],'you haven\'t access to this!')
def es_map_start(ev): SetUpProps()
def PropsForThisPage(Number=0):
    global PropsForThisPageValue
    PropsForThisPageValue = int(Number)
def Deleter(userid,choice,popupname):
    SendPopup(userid,'Props_Delete_Main')
    if choice == 'DeleteThis':
        index = getViewProp(userid)
        if index != None and es.entitygetvalue(index, "classname").startswith("prop_"):
            es.remove(index)
            es.tell(userid, 'Deleted prop #%s' %(index))
    if choice == 'DeleteAll':
        for entity_index in es.createentitylist():
            if str(es.entitygetvalue(entity_index, "classname")).startswith("prop_"):
                es.remove(entity_index)
def SendPopup(userid, popup, page=1):
    debugmsg = 0
    if debugmsg:
        es.msg("userid: %s" %(userid))
        es.msg("popup1: %s" %(popup))
        es.msg("page: %s" %(page))
    popup = popuplib.find(popup)
    if debugmsg: es.msg("popup2: %s" %(popup))
    if not isinstance(page, int):
        if debugmsg: es.msg("type != int, setting page to 1")
        page = 1
    popup.sendPage(userid, int(page))
def SpawnProp(userid,choice,popupname):
    CS = choice.split("--")
    SendPopup(userid,popupname,int(CS[0]))
    choice = CS[1]
    choice = choice.split(", ")
    SpawnProp2(str(userid),str(choice[3]),str(choice[6]),str(choice[4]),str(choice[5]))
def SpawnProp2(userid,name,path,type,radi):
    name = str(name).replace("'","")
    path = str(path).replace("'","")
    type = str(type).replace("'","")
    radi = str(radi).replace("'","")
    if str(type).lower() == 'physics':
        es.prop_physics_create(userid,path)
        PropLoc = playerlib.getPlayer(userid).getViewCoord()
    elif str(type).lower() == 'dynamic':
        es.prop_dynamic_create(userid,path)
        PropLoc = es.getindexprop(es.ServerVar("eventscripts_lastgive"), 'CBaseEntity.m_vecOrigin')
    else: return
    for CP in playerlib.getPlayerList('#alive'):
        if int(vecmath.distance(PropLoc,es.getplayerlocation(CP))) < int(radi):
            es.tell(userid, 'The prop is too close to the player %s' %(es.getplayername(CP)))
            es.remove(es.ServerVar("eventscripts_lastgive"))
def SetUpPropsMenu(category):
    temppropsmenu = popuplib.easymenu("Props_Props_%s"%category,None,SpawnProp)
    temppropsmenu.settitle("- Props\n-- Spawn Props\n--- %s" %(category))
    PropsForThisPage()
    PropsInThisCategory = {}
    for props in PropsFile:
        propsS = props.split("|")
        if (len(propsS) == 8):
            if (propsS[2] == category):
                PropsInThisCategory[propsS[3]] = propsS
    for Prop in sorted(PropsInThisCategory.keys()):
        if len(PropsInThisCategory) < 10:
            Page = 1
        else:
            Page = PropsForThisPageValue / 7 + 1
            PropsForThisPage(PropsForThisPageValue+1)
        temppropsmenu.addoption("%s--%s" %(Page,PropsInThisCategory[Prop]),Prop)
    temppropsmenu.submenu(10,"Props_Props_Main")
def SetUpProps():
    global PubVar
    PubVar = es.ServerVar("props_version","1.1CheeTaH-Public","Script Version")
    PubVar.set("1.1CheeTaH-Public")
    PubVar.makepublic()
    global Props_Props_Main
    Props_Props_Main = popuplib.easymenu('Props_Props_Main',None, SendPopup)
    Props_Props_Main.settitle("- Props\n-- Spawn Props")
    Props_Props_Main.submenu(10,Props_Main)
    PropCategorys = {}
    for CurrentLine in PropsFile:
        if str(CurrentLine).lower().startswith('|add prop|'):
            SL = CurrentLine.split('|')
            if len(SL) == 8:
                if SL[2] not in PropCategorys: PropCategorys[SL[2]] = SL[2]
    for cat in sorted(PropCategorys.keys()):
        Props_Props_Main.addoption("Props_Props_%s" %(cat),cat)
        SetUpPropsMenu(cat)
def SetUpRotate():
    for CurrentLine in RotateFile:
        if str(CurrentLine).lower().startswith('|rotatev|'):
            SL = CurrentLine.split('|')
            if len(SL) == 4: AddRotator(SL[2])
def AddRotator(Angles):
    Props_Rotate_Main.addoption('Props_Rotate_%s' %(Angles), '%s degress' %(Angles))
    Props_Temp_Rotate = popuplib.easymenu('Props_Rotate_%s' %(Angles),None, Rotater)
    Props_Temp_Rotate.submenu(10, 'Props_Rotate_Main')
    Props_Temp_Rotate.settitle("- Props\n-- Manage Props\n--- Rotate\n---- %s degress" %(Angles))
    Props_Temp_Rotate.addoption("+x","+x")
    Props_Temp_Rotate.addoption("+y","+y")
    Props_Temp_Rotate.addoption("+z","+z")
    Props_Temp_Rotate.addoption("-x","-x")
    Props_Temp_Rotate.addoption("-y","-y")
    Props_Temp_Rotate.addoption("-z","-z")
    Props_Temp_Rotate.addoption("--","Other rotating values")
def getViewProp(userid):
    returnvalue = None
    if es.exists("userid", userid):
        entities = es.createentityindexlist()
        for entity in entities:
            entities[entity]["targetname"] = es.entitygetvalue(entity, "targetname")
        es.entsetname(userid, "viewed_prop")
        for entity in entities:
            if es.entitygetvalue(entity, "targetname") != "viewed_prop":
                continue
            returnvalue = entity
            es.entitysetvalue(entity, "targetname", entities[entity]["targetname"])
            break
    return returnvalue
def Rotater(userid,choice,popupname):
    if choice == '--':
        SendPopup(userid,'Props_Rotate_Main')
        return
    SendPopup(userid,popupname)
    Value = str(popupname).replace('Props_Rotate_','')
    Value = float(Value)
    Index = getViewProp(userid)
    if Index == None: return
    Angle = es.getindexprop(Index, "CBaseEntity.m_angRotation")
    Angle = Angle.split(",")
    Angle1 = str(Angle[0])
    Angle2 = str(Angle[1])
    Angle3 = str(Angle[2])
    if choice == '+x': Angle1 = float(Angle1) + Value
    elif choice == '+z': Angle2 = float(Angle2) + Value
    elif choice == '+y': Angle3 = float(Angle3) + Value
    elif choice == '-x': Angle1 = float(Angle1) - Value
    elif choice == '-z': Angle2 = float(Angle2) - Value
    elif choice == '-y': Angle3 = float(Angle3) - Value
    es.entitysetvalue(Index, 'angles', ' '.join((str(Angle1),str(Angle2),str(Angle3))))